#######################################
# Plugin: Users                       #
# Functionality: Allow management     #
#  of users, login, logout, etc       #
#######################################

from flask import Blueprint
from flaschengeist.app import app

def register():
    return Blueprint('user', __name__)

#######################################
##              Routes               ##
#######################################
#dummy
@app.route("/")
def _dummy():
    return 'Noch funktioniert hier mal überhaupt nichts!'

@app.route("/login", methods=['POST'])
def _login():
    """ Login User

        Nothing to say.
        Login in User and create an AccessToken for the User.

        Returns:
            A JSON-File with createt Token or Errors
    """
    debug.info("Start log in.")
    data = request.get_json()
    username = data['username']
    password = data['password']
    debug.debug("username is {{ {} }}".format(username))
    try:
        user_agent = request.user_agent
        debug.info("search {{ {} }} in database".format(username))
        user = mainController.loginUser(username, password)
        debug.debug("user is {{ {} }}".format(user))
        token = accesTokenController.createAccesToken(user, user_agent=user_agent)
        debug.debug("accesstoken is {{ {} }}".format(token))
        debug.info("validate accesstoken")
        dic = accesTokenController.validateAccessToken(
            token, [USER, EXTERN]).user.toJSON()
        dic["token"] = token
        dic["accessToken"] = token
        debug.info("User {{ {} }} success login.".format(username))
        debug.info("return login {{ {} }}".format(dic))
        return jsonify(dic)
    except PermissionDenied as err:
        debug.warning("permission denied exception in logout", exc_info=True)
        return jsonify({"error": str(err)}), 401
    except Exception as err:
        debug.warning("exception in logout.", exc_info=True)
        return jsonify({"error": "permission denied"}), 401
