from ..logger import getDebugLogger
from datetime import datetime
debug = getDebugLogger()


class User():
    """ Database Object for User

        Table for all safed User

        Attributes:
            id: Id in Database as Primary Key.
            username: Username of the User to Login
            firstname: Firstname of the User
            lastname: Lastname of the User
            mail: mail address of the User
    """
    def __init__(self, data):
        debug.info("init user")
        if 'id' in data:
            self.id = int(data['id'])
        self.firstname = data['firstname']
        self.lastname = data['lastname']
        if 'mail' in data:
            self.mail = data['mail']
        else:
            self.mail = ''
        if 'username' in data:
            self.username = data['username']
        else:
            self.username = None
        debug.debug("user is {{ {} }}".format(self))

    def updateData(self, data):
        debug.info("update data of user")
        if 'firstname' in data:
            self.firstname = data['firstname']
        if 'lastname' in data:
            self.lastname = data['lastname']
        if 'mail' in data:
            self.mail = data['mail']
        if 'username' in data:
            self.username = data['username']

    def __repr__(self):
        return "User({}, {})".format(self.uid, self.username)


# TODO: user attributes (uid|key|value), getter, setter, has
